#include "stdafx.h"
#include "Global.h"
#include "CharacterTask.h"
#include "DrawManager.h"
#include "MathTool.h"

//----
// RXgN^
//----
DrawManager::DrawManager() :
	// zXN[
	  m_VirtualWH(1000, 1000)
	// XN[r[|[g
	, m_ViewRect()
{
}

//----
// fXgN^
//----
DrawManager::~DrawManager()
{
}

//----
// s܂
// return	true	I
//			false	ُI
//----
bool DrawManager::Initialize()
{
	return true;
}

//----
// ڂ폜܂
// param	pTask	o^ĂLN^[^XN
//----
void DrawManager::Erase(CharacterTask* pTask)
{
	// z瑖܂
	size_t uCount = size();
	for(int i = ((int)uCount - 1); i >= 0; i--)
	{
		if(pTask == at(i))
		{
			// ^XNo^O܂
			erase(begin() + i);
		}
	}
}

//----
// `s܂
//----
void DrawManager::Draw()
{
	// ʂNA܂
	g_Global.m_DirectDraw.m_OffScreen.Clear(RGB(0, 0, 0));

	// eLN^[^XN̕`s܂
	vector<CharacterTask*>::const_iterator it = begin();
	for(; it != end(); ++it)
	{
		(*it)->Draw(g_Global.m_DirectDraw.m_OffScreen);
	}

	// fobO`悵܂
	DrawDebug(g_Global.m_DirectDraw.m_OffScreen);

	//----
	// ʂɔf܂
	//----
	// ItXN[̃NbsOW߂܂
	RECT OffScreenRect;
	OffScreenRect.left = g_Global.m_DirectDraw.m_OffScreenRange.m_Width;
	OffScreenRect.top = g_Global.m_DirectDraw.m_OffScreenRange.m_Height;
	OffScreenRect.right = OffScreenRect.left + g_Global.m_DirectDraw.m_OffScreenInfo.dwWidth;
	OffScreenRect.bottom = OffScreenRect.top + g_Global.m_DirectDraw.m_OffScreenInfo.dwHeight;

	RECT ScreenRect;

	DDBLTFX DDBltFx;
	ZeroMemory(&DDBltFx, sizeof(DDBltFx));
	DDBltFx.dwSize = sizeof(DDBltFx);

	// tXN[
	if(g_Global.m_DirectDraw.m_bFullScreen == true)
	{
		// obNT[tFX̑傫߂܂
		ScreenRect.top = ScreenRect.left = 0;
		ScreenRect.right = g_Global.m_DirectDraw.m_ScreenInfo.dwWidth;
		ScreenRect.bottom = g_Global.m_DirectDraw.m_ScreenInfo.dwHeight;

		// ItXN[obNT[tFXɓ]܂
		// (BltFast ͎gpł܂)
		g_Global.m_DirectDraw.m_Back.m_pSurface->Blt(
			&ScreenRect,
			g_Global.m_DirectDraw.m_OffScreen.m_pSurface,
			&OffScreenRect,
			DDBLT_WAIT,
			&DDBltFx);

		// tbv
		g_Global.m_DirectDraw.m_pDDSPrimary->Flip(NULL, DDFLIP_WAIT);
	}
	// EBhE
	else
	{
		// EBhẼNCAg̈XN[n̍WƂċ߂܂
		GetClientRect(g_Global.m_DirectDraw.m_hWnd, &ScreenRect);
		POINT ScreenPoint;
		ScreenPoint.x = ScreenRect.left;
		ScreenPoint.y = ScreenRect.top;
		ClientToScreen(g_Global.m_DirectDraw.m_hWnd, &ScreenPoint);
		ScreenRect.left = ScreenPoint.x;
		ScreenRect.top = ScreenPoint.y;
		ScreenRect.right += ScreenPoint.x;
		ScreenRect.bottom += ScreenPoint.y;

		// ItXN[vC}T[tFXɓ]܂
		// (BltFast ͎gpł܂)
		g_Global.m_DirectDraw.m_pDDSPrimary->Blt(
			&ScreenRect,
			g_Global.m_DirectDraw.m_OffScreen.m_pSurface,
			&OffScreenRect,
			DDBLT_WAIT,
			&DDBltFx);
	}
}

//----
// `s܂
// param	rBack	wiobt@
// param	rSrc	`摜
// param	rPoint	`W
// param	rSize	`TCY
//----
void DrawManager::Draw(Texture& rBack, Texture& rSrc, PointD& rPoint, SizeI& rSize)
{
	if(rSrc.m_pSurface == NULL)
	{
		return;
	}

	PointI ScreenXY = ToVirtual(rPoint);

	RECT ImageRect;
	ImageRect.left = ImageRect.top = 0;
	ImageRect.right = rSize.m_Width;
	ImageRect.bottom = rSize.m_Height;
	rBack.m_pSurface->BltFast(
		ScreenXY.m_X, ScreenXY.m_Y,
		rSrc.m_pSurface,
		&ImageRect,
		DDBLTFAST_SRCCOLORKEY);

	//RECT ScreenRect;
	//ScreenRect.left = (DWORD)rPoint.m_dX;
	//ScreenRect.top = (DWORD)rPoint.m_dY;
	//ScreenRect.right = ScreenRect.left + (LONG)rSize.m_dWidth;
	//ScreenRect.bottom = ScreenRect.top + (LONG)rSize.m_dHeight;
	//HRESULT hResult = rBack.m_pSurface->Blt(
	//	&ScreenRect,
	//	rSrc.m_pSurface,
	//	&ImageRect,
	//	DDBLT_KEYSRC, NULL);
}

//----
// `s܂
// param	rBack	wiobt@
//----
void DrawManager::DrawDebug(Texture& rBack)
{
	// eڂ\܂
	map<size_t, Debug::ScreenItem>::const_iterator it = Debug::m_ScreenItem.begin();
	for(; it != Debug::m_ScreenItem.end(); ++it)
	{
		const Debug::ScreenItem& Item = it->second;

		HDC hDC;
		rBack.m_pSurface->GetDC(&hDC);
		PointI XY = ToScreen(Item.dwX, Item.dwY);
		TextOut(
			hDC, XY.m_X, XY.m_Y,
			Item.Message.c_str(), lstrlen(Item.Message.c_str()));
		rBack.m_pSurface->ReleaseDC(hDC);
	}

	// test line
	HDC hDC;
	rBack.m_pSurface->GetDC(&hDC);
	HPEN hPen = CreatePen(PS_SOLID, 1, RGB(0, 128, 255));
	HGDIOBJ hOldPen = SelectObject(hDC, hPen);
	HGDIOBJ hOldBrush = SelectObject(hDC, GetStockObject(NULL_BRUSH));
	PointI XY = ToScreen(0, 0);
	Rectangle(hDC, XY.m_X, XY.m_Y, XY.m_X + g_Global.m_OffScreenInfo.dwWidth, XY.m_X + g_Global.m_OffScreenInfo.dwHeight);
	SelectObject(hDC, hOldPen);
	SelectObject(hDC, hOldBrush);

	// test pixel
	SetPixel(hDC, XY.m_X, XY.m_Y, RGB(255, 0, 0));

	rBack.m_pSurface->ReleaseDC(hDC);
}

//----
// XN[Wɕϊ܂
// param	rScreenPoint	ϊXN[W
// return	ϊꂽzXN[W
//----
PointI DrawManager::ToScreen(const PointD& rScreenPoint) const
{
	return PointI(
		(int)(rScreenPoint.m_X + g_Global.m_DirectDraw.m_OffScreenRange.m_Width),
		(int)(rScreenPoint.m_Y + g_Global.m_DirectDraw.m_OffScreenRange.m_Height));
}

//----
// XN[Wɕϊ܂
// param	dwX		ϊXN[W
// param	dwY		ϊXN[W
// return	ϊꂽzXN[W
//----
PointI DrawManager::ToScreen(DWORD dwX, DWORD dwY) const
{
	return PointI(
		dwX + g_Global.m_DirectDraw.m_OffScreenRange.m_Width,
		dwY + g_Global.m_DirectDraw.m_OffScreenRange.m_Height);
}

//----
// zXN[Wɕϊ܂
// param	rScreenPoint	ϊXN[W
// return	ϊꂽzXN[W
//----
PointI DrawManager::ToVirtual(const PointD& rScreenPoint) const
{
	return PointI(
		(int)((rScreenPoint.m_X + g_Global.m_DirectDraw.m_OffScreenRange.m_Width - m_ViewRect.m_XY.m_X)),
		(int)(rScreenPoint.m_Y + g_Global.m_DirectDraw.m_OffScreenRange.m_Height - m_ViewRect.m_XY.m_Y));
}

//----
// zXN[Wɕϊ܂
// param	dwX		ϊXN[W
// param	dwY		ϊXN[W
// return	ϊꂽzXN[W
//----
PointI DrawManager::ToVirtual(DWORD dwX, DWORD dwY) const
{
	return PointI(
		dwX + g_Global.m_DirectDraw.m_OffScreenRange.m_Width - (DWORD)m_ViewRect.m_XY.m_X,
		dwY + g_Global.m_DirectDraw.m_OffScreenRange.m_Height - (DWORD)m_ViewRect.m_XY.m_Y);
}
