#pragma once

#include <vector>
#include "Texture.h"
#include "Rect.h"

using namespace std;

class CharacterTask;

//----
// LN^[`Ǘ
//----
class DrawManager : public vector<CharacterTask*>
{
public:
	// zXN[
	SizeD m_VirtualWH;
	// XN[r[|[g
	RectD m_ViewRect;

public:
	// RXgN^
	DrawManager();
	// fXgN^
	virtual ~DrawManager();
	// s܂
	bool Initialize();
	// ڂ폜܂
	void Erase(CharacterTask* pTask);
	// `s܂
	void Draw();
	void Draw(Texture& rBack, Texture& rSrc, PointD& rPoint, SizeI& rSize);
	// fobO̕`s܂
	void DrawDebug(Texture& rBack);

private:
	// XN[Wɕϊ܂
	PointI ToScreen(const PointD& rScreenPoint) const;
	PointI ToScreen(DWORD dwX, DWORD dwY) const;
	// zXN[Wɕϊ܂
	PointI ToVirtual(const PointD& rScreenPoint) const;
	PointI ToVirtual(DWORD dwX, DWORD dwY) const;
};
