#include "stdafx.h"
#include "Global.h"
#include "ImageTool.h"
#include <gdiplus.h>

using namespace Gdiplus;

//----
// RXgN^
//----
ImageTool::ImageTool() :
	// GDI+ g[N
	  m_GDIPlusToken(0)
	// J[L[
	, m_ColorKey(0)
{
	// 摜pX
	memset(m_ImagePath, 0, sizeof(m_ImagePath));
}

//----
// fXgN^
//----
ImageTool::~ImageTool()
{
	// s܂
	Release();
}

//----
// s܂
// return	true	I
//			false	ُI
//----
bool ImageTool::Initialize()
{
	// GDI+ ܂
	GdiplusStartupInput StartupInput;
	Status Result = GdiplusStartup(&m_GDIPlusToken, &StartupInput, NULL);
	#pragma warning(disable: 4482) // ȂI
	if(Result != Status::Ok)
	{
		return false;
	}

	return true;
}

//----
// s܂
//----
void ImageTool::Release()
{
	// GDI+ ܂
	if(m_GDIPlusToken != 0)
	{
		GdiplusShutdown(m_GDIPlusToken);
	}
}

//----
// 摜pXݒ肵܂
// param	pPath	摜pX
//----
void ImageTool::SetImagePath(const char* pPath)
{
	wsprintf(m_ImagePath, pPath);
}

//----
// 摜쐬܂
// param	pFileName	t@C
// param	rImage		摜ݒ肷IuWFNg
// return	true	I
//			false	ُI
//----
bool ImageTool::Create(const char* pFileName, Texture& rImage)
{
	// ɉ摜Ă܂
	if(rImage.m_pSurface != NULL)
	{
		rImage.Release();
	}

	// 摜pXƃt@CA܂
	char FullPath[_MAX_PATH];
	wsprintf(FullPath, "%s%s", ImageTool::m_ImagePath, pFileName);

	// 摜ǂݍ݂܂
	rImage.m_pSurface = g_Global.m_DirectDraw.LoadBitmap(FullPath, m_ColorKey);
	if(rImage.m_pSurface == NULL)
	{
		return false;
	}
	return true;
}
