#include "stdafx.h"
#include "InputManager.h"

//----
// RXgN^
//----
InputManager::InputManager() :
	// Rg[[
	  m_Controller()
	// WCXeBbN̐ڑ
	, m_bJoystick(false)
{
}

//----
// s܂
// return	true	I
//			false	ُI
//----
bool InputManager::Initialize()
{
	// WCXeBbN̐ڑԂmF܂
	if(GetJoystickConnectCount() != 0)
	{
		m_bJoystick = true;
	}

	return true;
}

//----
// WCXeBbN̐ڑmF܂
// return ڑ
//----
unsigned int InputManager::GetJoystickConnectCount() const
{
	JOYINFOEX JoyInfo;
	int njoyId = 0;
	MMRESULT dwResult;
	unsigned int uConnected = 0;
	while((dwResult = joyGetPosEx(njoyId++, &JoyInfo)) != JOYERR_PARMS)
	{
		if(dwResult == JOYERR_NOERROR)
		{
			uConnected++;
		}
	}
	return uConnected;
}

//----
// ͏s܂
//----
void InputManager::Execute()
{
	// xRg[[NA܂
	m_Controller.Reset();

	// L[{[h͂mF܂
	ProcessInputKeyboard();

	// ͂ꍇ̓Q[pbh̓͂mF܂
	if((m_bJoystick == true) && (m_Controller.m_uKeyStatus == 0))
	{
		// Q[pbh͏s܂
		ProcessInputGamePad();
	}
}

//----
// L[̉mF܂
// param	uPlayer		vC[ԍ
// param	uKey		L[(Controller::*)
// return	true	
//			false	
//----
bool InputManager::IsKeyDown(unsigned int, unsigned int uKey) const
{
	return ((m_Controller.m_uKeyStatus & uKey) != 0) ? true : false;
}

//----
// L[̉mF܂
// param	mF̉zL[
// return	true	
//			false	
//----
inline bool InputManager::IsKeyDown(int nKey) const
{
	return ((GetAsyncKeyState(nKey) & 0x8000) != 0) ? true : false;
}

//----
// L[{[h͏s܂
// remarks	͌ʂ Controller NXɐݒ肳܂
//----
void InputManager::ProcessInputKeyboard()
{
	//----
	// L[̏
	//----
	//----
	// L[
	//----
	if(IsKeyDown(VK_UP) == true)
	{
		if((m_Controller.m_uKeyStatus & Controller::LEFT_UP) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::LEFT_UP;
			m_Controller.m_uKeyStatus &= ~Controller::LEFT_DOWN;
		}
	}
	else if(IsKeyDown(VK_DOWN) == true)
	{
		if((m_Controller.m_uKeyStatus & Controller::LEFT_DOWN) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::LEFT_DOWN;
			m_Controller.m_uKeyStatus &= ~Controller::LEFT_UP;
		}
	}

	if(IsKeyDown(VK_RIGHT) == true)
	{
		if((m_Controller.m_uKeyStatus & Controller::LEFT_RIGHT) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::LEFT_RIGHT;
			m_Controller.m_uKeyStatus &= ~Controller::LEFT_LEFT;
		}
	}
	else if(IsKeyDown(VK_LEFT) == true)
	{
		if((m_Controller.m_uKeyStatus & Controller::LEFT_LEFT) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::LEFT_LEFT;
			m_Controller.m_uKeyStatus &= ~Controller::LEFT_RIGHT;
		}
	}

	//----
	// {^
	//----
	// X^[g
	if(
		(IsKeyDown('Q') == true) ||
		(IsKeyDown(VK_RETURN) == true)
	)
	{
		if ((m_Controller.m_uKeyStatus & Controller::START) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::START;
		}
	}
	// ZNg
	if(IsKeyDown('W') == true)
	{
		if ((m_Controller.m_uKeyStatus & Controller::SELECT) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::SELECT;
		}
	}
	// U 1 {^
	if(IsKeyDown('Z') == true)
	{
		if ((m_Controller.m_uKeyStatus & Controller::BUTTON_ATTACK1) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::BUTTON_ATTACK1;
		}
	}
	// U 2 {^
	if(IsKeyDown('X') == true)
	{
		if((m_Controller.m_uKeyStatus & Controller::BUTTON_ATTACK2) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::BUTTON_ATTACK2;
		}
	}
	// I
	if(IsKeyDown(VK_ESCAPE) == true)
	{
		if((m_Controller.m_uKeyStatus & Controller::FORCE_EXIT) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::FORCE_EXIT;
		}
	}

	//----
	// L[㎞̏
	//----
	if(IsKeyDown(VK_UP) == false)
	{
		m_Controller.m_uKeyStatus &= ~Controller::LEFT_UP;
	}
	if(IsKeyDown(VK_DOWN) == false)
	{
		m_Controller.m_uKeyStatus &= ~Controller::LEFT_DOWN;
	}
	if(IsKeyDown(VK_RIGHT) == false)
	{
		m_Controller.m_uKeyStatus &= ~Controller::LEFT_RIGHT;
	}
	if(IsKeyDown(VK_LEFT) == false)
	{
		m_Controller.m_uKeyStatus &= ~Controller::LEFT_LEFT;
	}
	if((IsKeyDown('Q') == false) && (IsKeyDown(VK_RETURN) == false))
	{
		m_Controller.m_uKeyStatus &= ~Controller::START;
	}
	if(IsKeyDown('W') == false)
	{
		m_Controller.m_uKeyStatus &= ~Controller::SELECT;
	}
	if(IsKeyDown('Z') == false)
	{
		m_Controller.m_uKeyStatus &= ~Controller::BUTTON_ATTACK1;
	}
	if(IsKeyDown('X') == false)
	{
		m_Controller.m_uKeyStatus &= ~Controller::BUTTON_ATTACK2;
	}
}

//----
// Q[pbh͏s܂
// remarks	͌ʂ Controller NXɐݒ肳܂
//----
void InputManager::ProcessInputGamePad()
{
	JOYINFOEX JoyInfo;
	JoyInfo.dwSize = sizeof(JoyInfo);
	JoyInfo.dwFlags = JOY_RETURNALL;
	joyGetPosEx(JOYSTICKID1, &JoyInfo);

	// L[̏
	//----
	// L[(AiÕP[XlāÃAiOl ON Ƃ܂)
	//----
	// 
	if(JoyInfo.dwYpos < (0x7FFF - 0x4000))
	{
		if((m_Controller.m_uKeyStatus & Controller::LEFT_UP) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::LEFT_UP;
			m_Controller.m_uKeyStatus &= ~Controller::LEFT_DOWN;
		}
	}
	// 
	else if(JoyInfo.dwYpos > (0x7FFF + 0x4000))
	{
		if((m_Controller.m_uKeyStatus & Controller::LEFT_DOWN) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::LEFT_DOWN;
			m_Controller.m_uKeyStatus &= ~Controller::LEFT_UP;
		}
	}

	// E
	if(JoyInfo.dwXpos > (0x7FFF + 0x4000))
	{
		if((m_Controller.m_uKeyStatus & Controller::LEFT_RIGHT) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::LEFT_RIGHT;
			m_Controller.m_uKeyStatus &= ~Controller::LEFT_LEFT;
		}
	}
	// 
	else if(JoyInfo.dwXpos < (0x7FFF - 0x4000))
	{
		if((m_Controller.m_uKeyStatus & Controller::LEFT_LEFT) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::LEFT_LEFT;
			m_Controller.m_uKeyStatus &= ~Controller::LEFT_RIGHT;
		}
	}

	// {^ 1
	if((JoyInfo.dwButtons & JOY_BUTTON1) != 0)
	{
		if ((m_Controller.m_uKeyStatus & Controller::BUTTON_ATTACK1) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::BUTTON_ATTACK1;
		}
	}
	// {^ 2
	if((JoyInfo.dwButtons & JOY_BUTTON2) != 0)
	{
		if ((m_Controller.m_uKeyStatus & Controller::BUTTON_ATTACK2) == 0)
		{
			m_Controller.m_uKeyStatus |= Controller::BUTTON_ATTACK2;
		}
	}

	//----
	// L[㎞̏
	//----
	//----
	// L[
	//----
	// 
	if(!(JoyInfo.dwYpos < (0x7FFF - 0x4000)))
	{
		m_Controller.m_uKeyStatus &= ~Controller::LEFT_UP;
	}
	// 
	if(!(JoyInfo.dwYpos > (0x7FFF + 0x4000)))
	{
		m_Controller.m_uKeyStatus &= ~Controller::LEFT_DOWN;
	}
	// E
	if(!(JoyInfo.dwXpos > (0x7FFF + 0x4000)))
	{
		m_Controller.m_uKeyStatus &= ~Controller::LEFT_RIGHT;
	}
	// 
	if(!(JoyInfo.dwXpos < (0x7FFF - 0x4000)))
	{
		m_Controller.m_uKeyStatus &= ~Controller::LEFT_LEFT;
	}
	// {^ 1
	if((JoyInfo.dwButtons & JOY_BUTTON1) == 0)
	{
		m_Controller.m_uKeyStatus &= ~Controller::BUTTON_ATTACK1;
	}
	// {^ 2
	if((JoyInfo.dwButtons & JOY_BUTTON2) == 0)
	{
		m_Controller.m_uKeyStatus &= ~Controller::BUTTON_ATTACK2;
	}
}
