#pragma once

#include <map>
#include "SoundID.h"
#include "SoundItem.h"
#include "SoundDeviceSE.h"
#include "SoundDeviceBGM.h"

using namespace std;

//----
// Ǘ
// remarks	first:SoundID::*, second:
//----
class SoundManager : public map<int, SoundItem>
{
public:
	// VXeƂẲ̋
	bool m_bEnableSystem;
	// SE ̋
	bool m_bEnableSE;
	// BGM ̋
	bool m_bEnableBGM;
	// t@CpX
	char m_SoundPath[_MAX_PATH];
	// SE foCX
	SoundDeviceSE m_DeviceSE;
	// BGM foCX
	SoundDeviceBGM m_DeviceBGM;

public:
	// RXgN^
	SoundManager();
	// fXgN^
	virtual ~SoundManager();
	// s܂
	bool Initialize(const char* pSoundPath);
	// pXݒ肵܂
	void SetSoundPath(const char* pPath);
	// ڂǉ܂
	void Add(int nID, int nType, int nDataFormatType, string FileName);
	void Add(int nID, int nType, int nDataFormatType, string FileName,
		int nLoopCount);
	void Add(
		int nID, int nType, int nDataFormatType, string FileName,
		int nLoopCount, long lSeekStartPoint, long lSeekEndPoint);
	// Đ܂
	void Play(int nID);
	void Play(int nID, int nLoopCount);
	void Play(const SoundItem& rItem, int nLoopCount);
	// ꎞ~܂
	void Pause(int nID);
	void Pause(const SoundItem& rItem);
	// ~܂
	void Stop(int nID);
	void Stop(const SoundItem& rItem);
	// o^Ă鉹̒擾܂
	DWORD GetMediaLength(int nID);
};
