#pragma once

#include "TaskID.h"

//----
// ^XN
//----
namespace TaskAttribute
{
	enum
	{
		// ftHg
		Default		    = 0x00000000,
		// LN^[
		Character		= 0x10000000,
	};
}

//----
// ^XN(P)NX
//----
class Task
{
public:
	// ^XN ID(TaskID Q)
	int m_nTaskID;
	// ^XN(TaskAttribute Q)
	unsigned int m_uTaskAttribute;
	// ^XNԍ
	int m_nTaskNo;
	// ^XNtO(true:, false:)
	bool m_bExist;
	// ^XNstO(true:s, false:~)
	bool m_bExecute;

public:
	// RXgN^
	Task();
	Task(int nTaskID);
	Task(int nTaskID, unsigned int uTaskAttribute);
	// fXgN^
	virtual ~Task();
	// s܂
	virtual void Initialize();
	// s܂
	virtual void Execute();
	// jۂɌĂяo܂
	virtual void Destroy();
};
