#include "stdafx.h"
#include "TaskManager.h"
#include "CharacterTask.h"
#include "DrawManager.h"

//----
// RXgN^
//----
TaskManager::TaskManager() :
	// `Ǘ
	m_pDrawManager(NULL)
{
}

//----
// fXgN^
//----
TaskManager::~TaskManager()
{
	// ܂
	Release();
}

//----
// ܂
//----
void TaskManager::Release()
{
	// o^ĂIuWFNgSĉ܂
	size_t uCount = size();
	for(size_t i = 0; i < uCount; i++)
	{
		Task* pTask = at(i);
		pTask->Destroy();
		delete pTask;
	}
	clear();
}

//----
// ^XNo^܂
// param	pTask	o^^XN
//----
void TaskManager::Add(Task* pTask)
{
	pTask->Initialize();
	push_back(pTask);
}

//----
// ^XNo^܂
// param	pCharacterTask	o^LN^[^XN
//----
void TaskManager::Add(CharacterTask* pCharacterTask)
{
	pCharacterTask->Initialize();
	m_pDrawManager->push_back(pCharacterTask);
	push_back(pCharacterTask);
}

//----
// o^Ă^XNs܂
//----
void TaskManager::Execute()
{
	// z瑖܂
	size_t uCount = size();
	for(int i = ((int)uCount - 1); i >= 0; i--)
	{
		Task* pTask = at(i);

		// ŏԂł΍폜܂
		if(pTask->m_bExist == false)
		{
			// LN^[̏ꍇ͕\ł܂
			if ((pTask->m_uTaskAttribute & TaskAttribute::Character) != 0)
			{
			    m_pDrawManager->Erase((CharacterTask*)pTask);
			}

			// jCxg𔭍s܂
			pTask->Destroy();

			// ^XNo^O܂
			erase(begin() + i);

			// ^XNj܂
			delete pTask;

			continue;
		}
		else
		{
			// ^XNs܂
			pTask->Execute();
		}
	}
}
