#include "stdafx.h"
#include "Global.h"
#include "Texture.h"

//----
// RXgN^
//----
Texture::Texture() :
	// T[tFX
	  m_pSurface(NULL)
{
}

//----
// fXgN^
//----
Texture::~Texture()
{
	// 摜܂
	Release();
}

//----
// 摜A^b`܂
// param	pSurface	A^b`T[tFX
// remarks	ȑOɃA^b`Ă摜͍폜܂
//----
void Texture::Attach(LPDIRECTDRAWSURFACE7 pSurface)
{
	if(m_pSurface != NULL)
	{
		Release();
	}
	m_pSurface = pSurface;
}

//----
// 摜܂
//----
void Texture::Release()
{
	// T[tFXĂ܂
	if(m_pSurface != NULL)
	{
		m_pSurface->Release();
		m_pSurface = NULL;
	}
}

//----
// NA܂
//----
void Texture::Clear(COLORREF Color)
{
	if(m_pSurface == NULL)
	{
		return;
	}

	DDBLTFX DDBltFx;
	ZeroMemory(&DDBltFx, sizeof(DDBltFx));
	DDBltFx.dwSize = sizeof(DDBltFx);
	DDBltFx.dwFillColor = Color;
	m_pSurface->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &DDBltFx);
}

//----
// TCY擾܂
// return	摜TCY
//----
SizeI Texture::GetSize() const
{
	if(m_pSurface == NULL)
	{
		return SizeI(0, 0);
	}
	DDSURFACEDESC2 DDSD;
	ZeroMemory(&DDSD, sizeof(DDSD));
	DDSD.dwSize = sizeof(DDSD);
	m_pSurface->GetSurfaceDesc(&DDSD);
	return SizeI(DDSD.dwWidth, DDSD.dwHeight);
}

//----
// J[L[ݒ肵܂
//----
void Texture::SetColorKey(COLORREF Color)
{
	if(m_pSurface == NULL)
	{
		return;
	}
	g_Global.m_DirectDraw.SetColorKey(m_pSurface, Color);
}
