#pragma once

#include "DirectDraw.h"
#include "ImageTool.h"
#include "TaskManager.h"
#include "DrawManager.h"
#include "InputManager.h"
#include "SoundManager.h"

class rScreenSize;

//----
// VXeǗNX
// VXeB̏ȂǂǗ܂
//----
class Global
{
public:
	// XN[
	DirectDraw::ScreenInfo m_ScreenInfo;
	// ItXN[
	DirectDraw::ScreenInfo m_OffScreenInfo;
	// DirectDraw
	DirectDraw	m_DirectDraw;
	// 摜c[
	ImageTool m_ImageTool;
	// ^XNǗ
	TaskManager m_TaskManager;
	// `Ǘ
	DrawManager m_DrawManager;
	// ͊Ǘ
	InputManager m_InputManager;
	// Ǘ
	SoundManager m_SoundManager;
	// t[[g
	DWORD m_dwFrameRate;
	// XgG[
	DWORD m_dwLastError;

public:
	// RXgN^
	Global();
	// fXgN^
	virtual ~Global();
	// s܂
	int Initialize(
		HWND hWnd,
		const DirectDraw::ScreenInfo& rScreenInfo,
		const DirectDraw::ScreenInfo& rOffScreenInfo,
		bool bFullScreen);
	// s܂
	bool Release();
	// Q[̎ss܂
	int Execute();
};

// O[oIuWFNg
extern Global g_Global;
