#pragma once

#include "Point.h"
#include "Size.h"

//----
// `
//----
template <class T>
class Rect
{
public:
	// 
	Point<T> m_XY;
	// ^
	Size<T> m_WH;

public:
	//----
	// RXgN^
	//----
	Rect() :
		  m_XY()
		, m_WH()
	{
	}

	//----
	// RXgN^
	// param	X		X
	// param	Y		Y
	// param	Width	
	// param	Height	
	//----
	Rect(const T& X, const T& Y, const T& Width, const T& Height) :
		  m_XY(X, Y)
		, m_WH(Width, Height)
	{
	}
};

typedef Rect<double> RectD;
typedef Rect<int> RectI;
