#include "stdafx.h"
#include <mbctype.h>
#include <mbstring.h>
#include "StringTool.h"

//----
// J}Zp[^̃p[^͂s܂
// param	pSource			p[^
// param	rDestinations	ꂽp[^W
// return	͂ꂽp[^̌
//----
size_t StringTool::GetParameterByComma(
	const char* pSource,
	vector<string>& rDestinations)
{
	return GetParameter(pSource, rDestinations, ",");
}

//----
// Zp[^p[^͂s܂
// param	pSource			p[^
// param	rDestinations	ꂽp[^W
// param	pSeparators		Zp[^
// return	͂ꂽp[^̌
//----
size_t StringTool::GetParameter(
	const char* pSource,
	vector<string>& rDestinations,
	const char* pSeparators)
{
	if(pSource == NULL)
	{
		return 0;
	}

	size_t uLength = strlen(pSource);
	int nCurrentIndex = 0;
	bool bSeparator = false;
	char ParamBuff[4096];
	ZeroMemory(ParamBuff, sizeof(ParamBuff));

	// Zp[^tO
	bool bEORSeparator = false;

	// TCY[v܂
	for(size_t i = 0; i < uLength; i++)
	{
		// R[hƔf 2 oCgRs[܂
		if(_mbsbtype((const unsigned char*)pSource + i, 0) == _MBC_LEAD)
		{
			// obt@O܂
			ParamBuff[nCurrentIndex] = pSource[i];
			nCurrentIndex++;
			i++;
			if(i == uLength)
			{
				break;
			}

			ParamBuff[nCurrentIndex] = pSource[i];
			nCurrentIndex++;

			// Rs[ł̂ŃZp[^tO𗎂Ƃ܂
			bEORSeparator = false;

			continue;
		}

		// '"' Ȃ΃[h؂ւ܂
		if(pSource[i] == '\"')
		{
			if(bSeparator == false)
			{
				bSeparator = true;
				continue;
			}
			else
			{
				// ̕ '"' ̏ꍇ '"' ̃GXP[vƂȂ̂ŁA
				// Rs[Ď̕Ɉړ܂
				// łȂꍇ '"' ̏Ił
				if(pSource[i + 1] != '\"')
				{
					bSeparator = false;
					continue;
				}
				else
				{
					// obt@O܂
					ParamBuff[nCurrentIndex] = pSource[i];
					nCurrentIndex++;
					i++;

					// Rs[ł̂ŃZp[^tO𗎂Ƃ܂
					bEORSeparator = false;

					continue;
				}
			}
		}

		// ؂蕶̎ '"' łĂȂꍇ
		// ̃p[^ɐi݂܂
		size_t uSeparatorSize = strlen(pSeparators);
		size_t nSeparatorLoop = 0;
		for(
			nSeparatorLoop = 0;
			nSeparatorLoop < uSeparatorSize;
			nSeparatorLoop++
		) {
			if(
				(pSource[i] ==
				pSeparators[nSeparatorLoop]) &&
				(bSeparator == false)
			) {
				// p[^Ƃ܂
				rDestinations.push_back(ParamBuff);
				ZeroMemory(ParamBuff, sizeof(ParamBuff));
				nCurrentIndex = 0;

				// Zp[^ƂȂ܂
				bEORSeparator = true;

				break;
			}
		}
		if(nSeparatorLoop != uSeparatorSize)
		{
			continue;
		}

		// obt@O܂
		ParamBuff[nCurrentIndex] = pSource[i];
		nCurrentIndex++;

		// Rs[ł̂ŃZp[^tO𗎂Ƃ܂
		bEORSeparator = false;
	}
	// [văobt@OĂ
	// p[^Ƃ܂
	if(strlen(ParamBuff))
	{
		rDestinations.push_back(ParamBuff);
	}
	// Ō̕Zp[^łA͋̃p[^݂܂
	if(bEORSeparator == TRUE)
	{
		rDestinations.push_back("") ;
	}

	return rDestinations.size();
}
